TimesToLoop equ 100;00;00;0 ; number of times to loop
include Part1.inc
; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in DoitX to a number (Doit1, Doit2,...Doit99)
DoitX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ret

;--------------------------------- Test Procs -------------------------------------------

;  Place any test procs or setup/checking procs you wish here

;---------------------------- Routines Being Timed --------------------------------------  

.data
Count dd 135 ;256 ;7 ; how many bytes we will do for this test
guards db 16 dup (0FFh)  ; guard bytes for multi byte procedures
align 16
dtst db 512 dup (0FFh)
tans dd 0
dans dd 0
.code
setup proc
	mov edi,offset dtst
	mov ecx,512  ; make full buffer of counts
	mov eax,0
	.repeat
		stosb
		inc eax
		dec ecx
	.until ecx==0
	; compute answer
	mov esi,offset dtst
	xor eax, eax
	xor ecx,ecx
	.repeat
		movzx edx, BYTE PTR [esi]
		add eax, edx
		inc esi
		inc ecx
	.until ecx==Count
	mov dans,eax	; save answer
	ret
setup EndP
.data
mmxmask db 255,00,255,00,255,0,255,0
qans dq 0
.code

align 16
SumBytes proc stdcall _pByteArray:ptr byte,_dwCount:dword
	option prologue:none
	option epilogue:none
	pByteArray equ <dword ptr [esp+1*4][4]>
	dwCount     equ <dword ptr [esp+2*4][4]>
	push ebx
	mov ecx,dwCount
	xor eax,eax
	mov edx,ecx
	shr ecx,3
	mov ebx,pByteArray
	jz @F
	pxor mm2,mm2
	pxor mm3,mm3
	.repeat
		movq mm0,[ebx]
		add ebx,8
		movq mm1,mm0
		punpcklbw mm0,mm2
		punpckhbw mm1,mm2
		paddw mm3,mm0
		paddw mm3,mm1
		sub ecx,1
	.until zero?
	movq mm0,mm3
	punpcklwd mm0,mm2
	punpckhwd mm3,mm2
	paddd mm0,mm3
	movd ecx,mm0
	add eax,ecx
	psrlq mm0,32
	movd ecx,mm0
	add eax,ecx
	@@: and edx,7
	jz @F
	.repeat
		movzx ecx,byte ptr[ebx]
		add eax,ecx
		add ebx,1
		sub edx,1
	.until zero?
	@@: pop ebx
	ret 2*4
	option prologue:prologuedef
	option epilogue:epiloguedef
SumBytes endp

Doit1:
    Desc 'driz mmx'
	call setup
    BeginCounter
	invoke SumBytes,addr dtst,Count
	mov tans,eax
    EndCounter
	mov eax,tans
	 .if eax != dans
		msg " error"
	.endif
	mov eax,TestNum
	add eax,6000
	inv SetDlgItemInt,hWin,eax,tans,0
    ret

Doit2:       ;---------------------------------------------------------------------------
	Desc 'mmx 1 Loop, interleaved fixed'
	call setup
	BeginCounter
		mov esi,offset dtst
		mov ecx,Count
		xor eax,eax
		shr ecx,4
		.if ecx!=0
			pxor mm0,mm0
			movq mm2,qword ptr [mmxmask]
			.repeat
				movq mm1,[esi]
				movq mm3,[esi+1]
				pand mm1,mm2
				movq mm4,[esi+8]
				paddw mm0,mm1
				pand mm3,mm2
				movq mm5,[esi+9]
				pand mm4,mm2
				pand mm5,mm2
				paddw mm4,mm5
				paddw mm0,mm3
				paddw mm0,mm4
				add esi,16
				sub ecx,1
			.until zero?
			movq qans,mm0
			movzx eax,word ptr qans
			movzx edx,word ptr [qans+2]
			add eax,edx
			movzx edx,word ptr [qans+4]
			add eax,edx
			movzx edx,word ptr [qans+6]
			add eax,edx
		.endif
		mov ecx,Count
		and ecx,0Fh		; remainder to do, up to 15 bytes.
		.if !Zero?
			.repeat
				movzx edx,byte ptr[esi]
				add eax,edx
				inc esi
				sub ecx,1
			.until zero?
		.endif

		mov tans,eax
	
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	mov eax,TestNum
	add eax,6000
	inv SetDlgItemInt,hWin,eax,tans,0
	ret

	

align 16
SumBytesUnrolled proc stdcall _pByteArray:ptr byte,_dwCount:dword
option prologue:none
option epilogue:none
pByteArray equ <dword ptr [esp+1*4]>
dwCount    equ <dword ptr [esp+2*4]>
pxor mm0,mm0
pxor mm1,mm1
movd mm4,edi
movd mm5,esi
mov edx,dwCount
mov esi,pByteArray
mov ecx,edx
shr ecx,3
and edx,7
lea edi,[esi+ecx*8]
add ecx,-32
add edx,-8
; 256 is to force DWORD displacement
lea esi,[esi-256+ecx*8]
lea edi,[edi+edx-1]
neg ecx
neg edx
imul ecx,sdword ptr block_size8
imul edx,sdword ptr block_size1
add ecx,offset block_start8
add edx,offset block_start1
jmp ecx
align 4
xi = 0
block_start8:
movq mm2,[esi+256+xi*8]
movq mm3,mm2
punpcklbw mm2,mm1
punpckhbw mm3,mm1
paddw mm0,mm2
paddw mm0,mm3
block_size8 = ($-block_start8)
rept 32-1
xi = xi + 1
movq mm2,[esi+256+xi*8]
movq mm3,mm2
punpcklbw mm2,mm1
punpckhbw mm3,mm1
paddw mm0,mm2
paddw mm0,mm3
endm
movq mm2,mm0
punpcklwd mm0,mm1
punpckhwd mm2,mm1
paddd mm0,mm2
movq mm2,mm0
punpckldq mm2,mm1
punpckhdq mm0,mm1
paddd mm0,mm2
movd eax,mm0
jmp edx
xi = 1
align 4
block_start1:
movzx ecx,byte ptr [edi+xi]
add eax,ecx
block_size1 = ($-block_start1)
rept 8-1
xi = xi + 1
movzx ecx,byte ptr [edi+xi]
add eax,ecx
endm
movd edi,mm4
movd esi,mm5
ret 2*4
option prologue:prologuedef
option epilogue:epiloguedef
SumBytesUnrolled endp

Doit4:
    Desc 'driz mmx unrolled'
	call setup
    BeginCounter
	invoke SumBytesUnrolled,addr dtst,Count
	mov tans,eax
    EndCounter
	mov eax,tans
	 .if eax != dans
		msg " error"
	.endif
	mov eax,TestNum
	add eax,6000
	inv SetDlgItemInt,hWin,eax,tans,0
    ret

   
;              ------------------------ end of timing tests --------------------
include Part2.inc